> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pineyard.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a WhatsApp template mapping

**Required scope:** `whatsapp.edit`


## OpenAPI

````yaml /api-reference/openapi.json patch /whatsapp/templates/{id}
openapi: 3.0.3
info:
  title: Pineyard API
  version: 1.0.0
  description: >-
    Programmatic access to agents, campaigns, calls, phone numbers, WhatsApp and
    results in your Pineyard workspace.
servers:
  - url: https://api.pineyard.ai
    description: Production
security:
  - bearerAuth: []
paths:
  /whatsapp/templates/{id}:
    patch:
      summary: Update a WhatsApp template mapping
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                purpose:
                  type: string
                  minLength: 1
                  maxLength: 80
                providerName:
                  type: string
                  minLength: 1
                  maxLength: 200
                languageCode:
                  type: string
                  minLength: 2
                  maxLength: 12
                  default: en
                category:
                  type: string
                  enum:
                    - MARKETING
                    - UTILITY
                    - AUTHENTICATION
                  default: UTILITY
                headerKind:
                  type: string
                  enum:
                    - NONE
                    - TEXT
                    - IMAGE
                    - DOCUMENT
                    - VIDEO
                  default: NONE
                headerBindings:
                  type: array
                  items:
                    oneOf:
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - literal
                          value:
                            type: string
                            maxLength: 1024
                        required:
                          - source
                          - value
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - contact_name
                          fallback:
                            type: string
                            maxLength: 200
                            default: there
                        required:
                          - source
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - contact_phone
                        required:
                          - source
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - lead_field
                          key:
                            type: string
                            minLength: 1
                            maxLength: 120
                          fallback:
                            type: string
                            maxLength: 1024
                            default: ''
                        required:
                          - source
                          - key
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - contact_field
                          key:
                            type: string
                            minLength: 1
                            maxLength: 120
                          fallback:
                            type: string
                            maxLength: 1024
                            default: ''
                        required:
                          - source
                          - key
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - campaign_name
                        required:
                          - source
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - workspace_name
                        required:
                          - source
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - media_url
                        required:
                          - source
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - short_link
                          linkSource:
                            type: string
                            enum:
                              - payment
                              - recovery
                              - argument
                        required:
                          - source
                          - linkSource
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - tracked_url
                          url:
                            type: string
                            maxLength: 2048
                            format: uri
                          utm:
                            type: object
                            properties:
                              source:
                                type: string
                                maxLength: 120
                              medium:
                                type: string
                                maxLength: 120
                              campaign:
                                type: string
                                maxLength: 200
                              content:
                                type: string
                                maxLength: 200
                        required:
                          - source
                          - url
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - argument
                          key:
                            type: string
                            minLength: 1
                            maxLength: 120
                          fallback:
                            type: string
                            maxLength: 1024
                            default: ''
                        required:
                          - source
                          - key
                  maxItems: 24
                bodyBindings:
                  type: array
                  items:
                    oneOf:
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - literal
                          value:
                            type: string
                            maxLength: 1024
                        required:
                          - source
                          - value
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - contact_name
                          fallback:
                            type: string
                            maxLength: 200
                            default: there
                        required:
                          - source
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - contact_phone
                        required:
                          - source
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - lead_field
                          key:
                            type: string
                            minLength: 1
                            maxLength: 120
                          fallback:
                            type: string
                            maxLength: 1024
                            default: ''
                        required:
                          - source
                          - key
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - contact_field
                          key:
                            type: string
                            minLength: 1
                            maxLength: 120
                          fallback:
                            type: string
                            maxLength: 1024
                            default: ''
                        required:
                          - source
                          - key
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - campaign_name
                        required:
                          - source
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - workspace_name
                        required:
                          - source
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - media_url
                        required:
                          - source
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - short_link
                          linkSource:
                            type: string
                            enum:
                              - payment
                              - recovery
                              - argument
                        required:
                          - source
                          - linkSource
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - tracked_url
                          url:
                            type: string
                            maxLength: 2048
                            format: uri
                          utm:
                            type: object
                            properties:
                              source:
                                type: string
                                maxLength: 120
                              medium:
                                type: string
                                maxLength: 120
                              campaign:
                                type: string
                                maxLength: 200
                              content:
                                type: string
                                maxLength: 200
                        required:
                          - source
                          - url
                      - type: object
                        properties:
                          source:
                            type: string
                            enum:
                              - argument
                          key:
                            type: string
                            minLength: 1
                            maxLength: 120
                          fallback:
                            type: string
                            maxLength: 1024
                            default: ''
                        required:
                          - source
                          - key
                  maxItems: 24
                buttonBindings:
                  type: object
                  additionalProperties:
                    type: array
                    items:
                      oneOf:
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - literal
                            value:
                              type: string
                              maxLength: 1024
                          required:
                            - source
                            - value
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - contact_name
                            fallback:
                              type: string
                              maxLength: 200
                              default: there
                          required:
                            - source
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - contact_phone
                          required:
                            - source
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - lead_field
                            key:
                              type: string
                              minLength: 1
                              maxLength: 120
                            fallback:
                              type: string
                              maxLength: 1024
                              default: ''
                          required:
                            - source
                            - key
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - contact_field
                            key:
                              type: string
                              minLength: 1
                              maxLength: 120
                            fallback:
                              type: string
                              maxLength: 1024
                              default: ''
                          required:
                            - source
                            - key
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - campaign_name
                          required:
                            - source
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - workspace_name
                          required:
                            - source
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - media_url
                          required:
                            - source
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - short_link
                            linkSource:
                              type: string
                              enum:
                                - payment
                                - recovery
                                - argument
                          required:
                            - source
                            - linkSource
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - tracked_url
                            url:
                              type: string
                              maxLength: 2048
                              format: uri
                            utm:
                              type: object
                              properties:
                                source:
                                  type: string
                                  maxLength: 120
                                medium:
                                  type: string
                                  maxLength: 120
                                campaign:
                                  type: string
                                  maxLength: 200
                                content:
                                  type: string
                                  maxLength: 200
                          required:
                            - source
                            - url
                        - type: object
                          properties:
                            source:
                              type: string
                              enum:
                                - argument
                            key:
                              type: string
                              minLength: 1
                              maxLength: 120
                            fallback:
                              type: string
                              maxLength: 1024
                              default: ''
                          required:
                            - source
                            - key
                    maxItems: 24
                bodyPreview:
                  type: string
                  nullable: true
                  maxLength: 4000
                senderId:
                  type: string
                  nullable: true
                components:
                  type: array
                  items:
                    oneOf:
                      - type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - HEADER
                          format:
                            type: string
                            enum:
                              - TEXT
                              - IMAGE
                              - DOCUMENT
                              - VIDEO
                          text:
                            type: string
                            maxLength: 60
                          example:
                            type: object
                            properties:
                              header_text:
                                type: array
                                items:
                                  type: string
                              header_handle:
                                type: array
                                items:
                                  type: string
                        required:
                          - type
                          - format
                      - type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - BODY
                          text:
                            type: string
                            minLength: 1
                            maxLength: 1024
                          example:
                            type: object
                            properties:
                              body_text:
                                type: array
                                items:
                                  type: array
                                  items:
                                    type: string
                            required:
                              - body_text
                        required:
                          - type
                          - text
                      - type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - FOOTER
                          text:
                            type: string
                            minLength: 1
                            maxLength: 60
                        required:
                          - type
                          - text
                      - type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - BUTTONS
                          buttons:
                            type: array
                            items:
                              oneOf:
                                - type: object
                                  properties:
                                    type:
                                      type: string
                                      enum:
                                        - QUICK_REPLY
                                    text:
                                      type: string
                                      minLength: 1
                                      maxLength: 25
                                  required:
                                    - type
                                    - text
                                - type: object
                                  properties:
                                    type:
                                      type: string
                                      enum:
                                        - URL
                                    text:
                                      type: string
                                      minLength: 1
                                      maxLength: 25
                                    url:
                                      type: string
                                      maxLength: 2000
                                      format: uri
                                    example:
                                      type: array
                                      items:
                                        type: string
                                  required:
                                    - type
                                    - text
                                    - url
                                - type: object
                                  properties:
                                    type:
                                      type: string
                                      enum:
                                        - PHONE_NUMBER
                                    text:
                                      type: string
                                      minLength: 1
                                      maxLength: 25
                                    phone_number:
                                      type: string
                                      minLength: 5
                                      maxLength: 20
                                  required:
                                    - type
                                    - text
                                    - phone_number
                            minItems: 1
                            maxItems: 10
                        required:
                          - type
                          - buttons
                  maxItems: 4
                sampleValues:
                  type: object
                  additionalProperties:
                    nullable: true
                headerMediaFileName:
                  type: string
                  nullable: true
                  maxLength: 200
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                  purpose:
                    type: string
                  providerName:
                    type: string
                  languageCode:
                    type: string
                  category:
                    type: string
                    enum:
                      - MARKETING
                      - UTILITY
                      - AUTHENTICATION
                  providerCategory:
                    type: string
                    nullable: true
                    enum:
                      - MARKETING
                      - UTILITY
                      - AUTHENTICATION
                  headerKind:
                    type: string
                    enum:
                      - NONE
                      - TEXT
                      - IMAGE
                      - DOCUMENT
                      - VIDEO
                  headerBindings:
                    type: array
                    items:
                      nullable: true
                  bodyBindings:
                    type: array
                    items:
                      nullable: true
                  buttonBindings:
                    type: object
                    additionalProperties:
                      nullable: true
                  bodyPreview:
                    type: string
                    nullable: true
                  status:
                    type: string
                    enum:
                      - DRAFT
                      - PENDING
                      - APPROVED
                      - REJECTED
                      - DISABLED
                  senderId:
                    type: string
                    nullable: true
                  createdAt:
                    type: string
                  updatedAt:
                    type: string
                  components:
                    type: array
                    items:
                      nullable: true
                  sampleValues:
                    type: object
                    additionalProperties:
                      nullable: true
                  rejectionReason:
                    type: string
                    nullable: true
                  providerCheckedAt:
                    type: string
                    nullable: true
                  submissionIsAutomatic:
                    type: boolean
                  requiresRuntimeContext:
                    type: boolean
                  headerMediaFileName:
                    type: string
                    nullable: true
                  headerMediaAttached:
                    type: boolean
                  clicks:
                    type: number
                  trackedLinks:
                    type: number
                required:
                  - id
                  - purpose
                  - providerName
                  - languageCode
                  - category
                  - headerKind
                  - headerBindings
                  - bodyBindings
                  - buttonBindings
                  - bodyPreview
                  - status
                  - senderId
                  - createdAt
                  - updatedAt
                  - components
                  - sampleValues
                  - rejectionReason
                  - providerCheckedAt
                  - submissionIsAutomatic
                  - requiresRuntimeContext
                  - headerMediaFileName
                  - headerMediaAttached
                  - clicks
                  - trackedLinks
        '400':
          description: >-
            - `invalid_body`: The request body (or query) failed validation.
            Details are in `issues` (or `detail`). `422` on `POST
            /v1/campaigns/{campaignId}/leads`.

            - `template_sender_invalid`: Template's sender is invalid.
        '401':
          description: >-
            - `invalid_api_key`: The API key is unknown, revoked or expired, or
            its workspace was deleted.

            - `unauthorized`: No `Authorization: Bearer` header, or an empty
            token.
        '403':
          description: >-
            - `api_key_not_scoped`: A key issued without scopes was used outside
            `/v1`.

            - `api_key_owner_inactive`: The member the key acts for was removed
            or suspended.

            - `forbidden`: The key lacks the permission named in
            `requiredPermission`, or the resource belongs to another workspace.

            - `workspace_pending_approval`: The workspace has not been approved
            yet.

            - `workspace_suspended`: The workspace is suspended.
        '404':
          description: >-
            - `not_found`: The resource does not exist in your workspace, or the
            feature is not enabled for it.

            - `template_not_found`: Template id not in this workspace (400 in
            order-notification rules).
        '409':
          description: '- `template_already_exists`: Template name already exists.'
        '429':
          description: '- `rate_limited`: Too many requests.'
        '500':
          description: >-
            - `internal_error`: An unexpected error. A `400` with this code
            usually means the body is not valid JSON; a `413` means the body is
            larger than 1 MB.
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: Your API key, e.g. `pk_live_xxxxxxxxxxxxxxxxxxxxxxxx`.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.